%2-bit pattern detection for Hartley's CSE algorithm
%cb: a vector responding to a bit string
%a bit could be 1, 0, -1, 2, -2, and other subexpressions identified in Hartley's CSE
function LBPT = bpdetect_Har(cb)

% cb = CSD(0.234,16);
LBPT = [];
% nz = nzbitdetect_Har(cb);
nz = find(cb);

if length(nz) >= 2 
    k = 2;  
    pt=1;
    bpi_mat = nchoosek(nz, k);
    for kk=1:size(bpi_mat,1) %for each row of bit patter index matrix
        bpi = bpi_mat(kk,:);
        bp = zeros(1, bpi(k)-bpi(1)+1);
        bpi_tmp = bpi - bpi(1)+1;
        for i =1:k %put the nonzero bits into bp
            bp(bpi_tmp(i)) = cb(bpi(i));
        end
        [IsIn, index, IsOverlapped]=BPyuBPT_Har(bp, bpi, LBPT);
        if IsIn==0 
            %if not in, add the bp, bpi into the bpt and freq=1
            LBPT(pt).bpi=bpi;
            LBPT(pt).bp=bp;
            LBPT(pt).freq=1;
            pt=pt+1;
        elseif ~IsOverlapped 
            %if not overlapped, add the bpi and increment freq by 1
            LBPT(index).bpi=[LBPT(index).bpi; bpi];
            LBPT(index).freq=LBPT(index).freq+1;
            %if overlapped, no action required
        end   
    end  
end